/* Subject handling routines for uushred 4.2pl3  by Mark Neidengard
   (mneideng@ugcs.caltech.edu)  Circa 6-1996 */


int subject_handle (string,sub_array,index,sub_switch, kill_number, kill_array)
char *string;
struct subject_line *sub_array;
int index;
struct switches *sub_switch;
int kill_number;
char **kill_array;
{
int source_count=9,target_count=0;

while (string[source_count]) {
   if (string[source_count]==' ')
      if (string[source_count-1]==' ') {
         ++source_count;
         continue;
      }

   if (sub_switch->killfile) {
     if (Kill(string+source_count,kill_array,kill_number)) return 0;
   }

   if (sub_switch->avoidance)
   if (string[source_count]=='Q')
      if (string[source_count-1]=='A')
         if (string[source_count-2]=='F')
            return 0;
   if (sub_switch->re_skip)
   if (string[source_count]==':')
      if (string[source_count-1]=='e')
         if (string[source_count-2]=='R')
            return 0;
   if (string[source_count] >= '0' && string[source_count] <= '9')
      if (string[source_count-1] < '0' || string[source_count-1] > '9')
      if (string[source_count+1] < '0' || string[source_count+1] > '9')
         sub_array[index].string[target_count++]='0';
   sub_array[index].string[target_count]=
      (string[source_count] >= 'A' && string[source_count] <= 'Z')?
      string[source_count]+32:string[source_count];
   ++source_count;++target_count;
   }
sub_array[index].string[target_count]='\0';
return 1;
}

swap (the_array,first,second)
struct subject_line the_array[];
int first,second;
{
  char temp[MAXBUFSIZE];
  int  tmp;

  strcpy (temp,the_array[first].string);
  strcpy (the_array[first].string,the_array[second].string);
  strcpy (the_array[second].string,temp);
  tmp=the_array[first].start;
  the_array[first].start=the_array[second].start;
  the_array[second].start=tmp;
  tmp=the_array[first].finish;
  the_array[first].finish=the_array[second].finish;
  the_array[second].finish=tmp;
  tmp=the_array[first].argnum;
  the_array[first].argnum=the_array[second].argnum;
  the_array[second].argnum=tmp;
}

quicksort (subject_array,left,right)
struct subject_line subject_array[];
int left,right;
{
  char partition[MAXBUFSIZE];
  int seek_right;
  int seek_left;

  if  (right>left) {
   seek_right=left-1;seek_left=right;
   strcpy (partition,subject_array[right].string);

   for (;;) {
      while (strcmp(subject_array[++seek_right].string,partition) < 0)if(seek_right==right)break;
      while (strcmp(subject_array[--seek_left].string,partition) > 0)if(seek_left==left)break;
      if (seek_right>=seek_left) break;
      swap (subject_array,seek_right,seek_left);
   }

   swap (subject_array,seek_right,right);
   quicksort (subject_array, left,seek_right-1);
   quicksort (subject_array, seek_right+1, right);
  }
}
