/* Decode routines for uushred 4.2pl3  by Mark Neidengard
   (mneideng@ugcs.caltech.edu)  Circa 6-1996 */


doaline(s)
     char s[];
/*
 * copy from in to out, decoding as you go along. for uuconvert.
 */
 
 
{
  char *bp;
  int n;
  if ((n=DEC(s[0])) > 0)
    {
      bp = &s[1];
      while (n > 0)
        outdec(bp, n), bp += 4, n -= 3;
    }
}
 
/*
 * output a group of 3 bytes (4 input characters).
 * the input chars are pointed to by p, they are to
 * be output to file f.  n is used to tell us not to
 * output all of them at the end of the file.
 */
outdec(p, n)
     char *p;
{
  int c1, c2, c3;
  
  c1 = DEC(*p) << 2 | DEC(p[1]) >> 4;
  c2 = DEC(p[1]) << 4 | DEC(p[2]) >> 2;
  c3 = DEC(p[2]) << 6 | DEC(p[3]);
  if (n >= 1) putc(c1, out);
  if (n >= 2) putc(c2, out);
  if (n >= 3) putc(c3, out);
}

