/* Killfile routines for uushred 4.2pl3  by Mark Neidengard
   (mneideng@ugcs.caltech.edu)  Circa 6-1996 */


build_kill(the_array,the_switch,kill_number)
char ***the_array;
struct switches *the_switch;
int *kill_number;
{
  FILE *filename;
  char buffer[81];
  int counter=0;

  if ((filename=fopen(the_switch->kill_name,"r"))==NULL) {
    if (*(the_switch->kill_name))
      printf ("Killfile \"%s\" not found\n",the_switch->kill_name);
    if ((filename=fopen(strcat(getenv("HOME"),"/News/.uuskill"),"r"))==NULL) {
      printf ("BLAUGH!\n");
      the_switch->killfile=0;
       return;
    }
    if (the_switch->phase_info)
      printf ("Using default killfile\n");
  }
  else printf ("Using killfile %s\n",the_switch->kill_name);

  while (!(feof(filename))) {
    fgets(buffer,80,filename); 
    ++counter;
  }
  *the_array=(char ** )calloc(--counter,sizeof(char *));
  *kill_number=counter;   /* we keep track of how many lines there are in the */
                          /* killfile */
  for (--counter;counter>=0;--counter)
    (*the_array)[counter]=(char * )calloc(80,sizeof(char));
  rewind(filename);
  for (counter=0;!feof(filename);counter++) {
    fgets(buffer,80,filename);
    if (feof(filename)) break;
    strcpy ((*the_array)[counter],buffer);
  }
}

int Kill(string,kill_array,kill_number)
char *string;
char **kill_array;
int kill_number;
{
  for (--kill_number;kill_number>=0;--kill_number)
   if (!strncmp(string,kill_array[kill_number],strlen(kill_array[kill_number])-1))
     return 1;
  return 0;
}

