/* Structure definitions for uushred 4.2pl3 by Mark Neidengard
   (mneideng@ugcs.caltech.edu)  Circa 6-1996 */

 
struct switches {
   int avoidance; /* avoid FAQ pieces (-a) */
   int correlate; /* multipart correlator (-c) */
   int files_made; /* output file check (-f) */
   int input_sub; /* input subject display (-i) */
   int killfile; /* use killfile or not (-k) */
   int no_decode; /* reorder pieces but do not decode (-n) */
   int phase_info; /* show phases of decode (-p) */
   int pipeline; /* input from stdin (--) */
   int re_skip; /* skip Re: subject lines (-r) */
   int sorted_sub; /* sorted subject display (-s) */
   char kill_name[30]; /* name of killfile (for -k) */
   char uncorrelated_out[30]; /* where to put uncorrelated stuff (for -c) */
   char undecoded_out[30]; /* where to save undecoded stuff (for -n) */
};
 
struct subject_line {
  char string[MAXBUFSIZE];
  int argnum;
  int start;
  int finish;
  int correlated;  /* 1 = "uncorrelated" */
}

